% Created 2017-12-13 Wed 15:40
% Intended LaTeX compiler: pdflatex
\documentclass[a4paper]{article}
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{graphicx}
\usepackage{grffile}
\usepackage{longtable}
\usepackage{wrapfig}
\usepackage{rotating}
\usepackage[normalem]{ulem}
\usepackage{amsmath}
\usepackage{textcomp}
\usepackage{amssymb}
\usepackage{capt-of}
\usepackage{hyperref}
\author{R.S. Bhalla}
\date{\today}
\title{Multiple Regressions}
\hypersetup{
 pdfauthor={R.S. Bhalla},
 pdftitle={Multiple Regressions},
 pdfkeywords={},
 pdfsubject={},
 pdfcreator={Emacs 25.3.2 (Org mode 9.1.4)}, 
 pdflang={English}}
\begin{document}

\maketitle
\setcounter{tocdepth}{2}
\tableofcontents


\section*{Summary}
\label{sec:org85afd09}

\begin{itemize}
\item Run a multiple regression on the dataset: \url{./dataset\_enrollmentForecast.csv}
\item Based on the tutorial: \url{https://www.r-bloggers.com/r-tutorial-series-multiple-linear-regression/} and the even more detailed tutorial \url{https://petolau.github.io/Forecast-double-seasonal-time-series-with-multiple-linear-regression-in-R/}.
\item With additional chunks for visualisation borrowed from StackOverflow.
\end{itemize}

\subsection*{When to use multiple regression}
\label{sec:org239fe15}

Often we have two predictors (independent variables) which explain a result (dependent variable) . In this case the unemployment rate (UNEM) and number of spring high school graduates (HGRAD) to predict the fall enrollment (ROLL).

\section*{The code}
\label{sec:org478ac08}

\subsection*{Set environment}
\label{sec:orgc594dcd}

\begin{verbatim}
setwd("~/Events/Workshops/R_101/Tutorials/MultipleLinearRegressions")
\end{verbatim}

\begin{verbatim}
/home/udumbu/rsb/Events/Workshops/R_101/Tutorials/MultipleLinearRegressions
\end{verbatim}

\subsection*{Import data}
\label{sec:org4749794}

\begin{verbatim}
datavar <- read.csv("dataset_enrollmentForecast.csv")
summary(datavar)
cat("\n")
head(datavar)
\end{verbatim}

\begin{verbatim}
      YEAR         ROLL            UNEM            HGRAD            INC      
 Min.   : 1   Min.   : 5501   Min.   : 5.700   Min.   : 9552   Min.   :1923  
 1st Qu.: 8   1st Qu.:10167   1st Qu.: 7.000   1st Qu.:15723   1st Qu.:2351  
 Median :15   Median :14395   Median : 7.500   Median :17203   Median :2863  
 Mean   :15   Mean   :12707   Mean   : 7.717   Mean   :16528   Mean   :2729  
 3rd Qu.:22   3rd Qu.:14969   3rd Qu.: 8.200   3rd Qu.:18266   3rd Qu.:3127  
 Max.   :29   Max.   :16081   Max.   :10.100   Max.   :19800   Max.   :3345

  YEAR ROLL UNEM HGRAD  INC
1    1 5501  8.1  9552 1923
2    2 5945  7.0  9680 1961
3    3 6629  7.3  9731 1979
4    4 7556  7.5 11666 2030
5    5 8716  7.0 14675 2112
6    6 9369  6.4 15265 2192
\end{verbatim}

\subsection*{Visualise the data}
\label{sec:orgfd82cff}
\begin{verbatim}
libs <- c("ggplot2", "reshape2")
lapply(libs, require, character.only = TRUE)
ggdat <- melt(datavar, value.name = "Value", variable.name = "Predictor", id.vars = "ROLL", measure.vars = c("UNEM", "HGRAD"))
ggplot(data = ggdat, mapping = aes(x = ROLL, y = Value))+
geom_point() +
facet_wrap(nrow = 2, scales = "free_y", facets = "Predictor")
\end{verbatim}

\begin{center}
\includegraphics[width=.9\linewidth]{unemployment.png}
\end{center}

\subsection*{Testing a linear model}
\label{sec:org87abc15}

We know that a linear model won't work. But lets see how it performs anyway. 

\begin{verbatim}
fit.lm <- lm(formula = ROLL ~ UNEM, data = datavar)
cat("\n")
summary(fit.lm)
\end{verbatim}

\begin{verbatim}


Call:
lm(formula = ROLL ~ UNEM, data = datavar)

Residuals:
    Min      1Q  Median      3Q     Max 
-7640.0 -1046.5   602.8  1934.3  4187.2 

Coefficients:
            Estimate Std. Error t value Pr(>|t|)  
(Intercept)   3957.0     4000.1   0.989   0.3313  
UNEM          1133.8      513.1   2.210   0.0358 *
---
Signif. codes:  0 ‘***’ 0.001 ‘**’ 0.01 ‘*’ 0.05 ‘.’ 0.1 ‘ ’ 1

Residual standard error: 3049 on 27 degrees of freedom
Multiple R-squared:  0.1531,	Adjusted R-squared:  0.1218 
F-statistic: 4.883 on 1 and 27 DF,  p-value: 0.03579
\end{verbatim}

\begin{verbatim}
ggplot(data = data.frame(Fitted_values = fit.lm$fitted.values,
			 Residuals = fit.lm$residuals),
       aes(Fitted_values, Residuals)) +
  geom_point(size = 1.7) +
  geom_smooth() +
  geom_hline(yintercept = 0, color = "red", size = 1) +
  labs(title = "Fitted values vs Residuals")
\end{verbatim}

\begin{center}
\includegraphics[width=.9\linewidth]{fit_lm.png}
\end{center}

\subsection*{Testing a multiple regression}
\label{sec:orgaa96283}

Clearly just employment doesn't explain the number of people applying for work. Lets add the number of graduates and run a multiple regression.

\begin{verbatim}
fit.lmm <- lm(formula = ROLL ~ UNEM + HGRAD, data = datavar)
cat("\n")
summary(fit.lmm)
\end{verbatim}

\begin{verbatim}


Call:
lm(formula = ROLL ~ UNEM + HGRAD, data = datavar)

Residuals:
    Min      1Q  Median      3Q     Max 
-2102.2  -861.6  -349.4   374.5  3603.5 

Coefficients:
              Estimate Std. Error t value Pr(>|t|)    
(Intercept) -8.256e+03  2.052e+03  -4.023  0.00044 ***
UNEM         6.983e+02  2.244e+02   3.111  0.00449 ** 
HGRAD        9.423e-01  8.613e-02  10.941 3.16e-11 ***
---
Signif. codes:  0 ‘***’ 0.001 ‘**’ 0.01 ‘*’ 0.05 ‘.’ 0.1 ‘ ’ 1

Residual standard error: 1313 on 26 degrees of freedom
Multiple R-squared:  0.8489,	Adjusted R-squared:  0.8373 
F-statistic: 73.03 on 2 and 26 DF,  p-value: 2.144e-11
\end{verbatim}

From the above we know that:

\begin{itemize}
\item Intercept is -8255.8
\item Coefficient for the unemployment rate is 698.2, and the c
\item Coefficient for number of spring high school graduates is 0.9.
\end{itemize}

Also the number of graduating high school students are significantly affecting the rolls.

If you want to extract this as part of the code:

\begin{verbatim}
fit.lm$coefficients
\end{verbatim}

\begin{verbatim}
(Intercept)        UNEM 
   3957.029    1133.826
\end{verbatim}

Now look at the original formula: 

\begin{verbatim}
ROLL ~ UNEM + HGRAD
\end{verbatim}

In plain English this can be translated as Enrolment = -8255.8 + 698.2 * Unemployment Rate + 0.9 * Number of High School Graduates.

Lets now re-use the code we wrote for the linear model to see how will it fits the data.

\begin{verbatim}
ggplot(data = data.frame(Fitted_values = fit.lmm$fitted.values,
			 Residuals = fit.lmm$residuals),
       aes(Fitted_values, Residuals)) +
  geom_point(size = 1.7) +
  geom_smooth() +
  geom_hline(yintercept = 0, color = "red", size = 1) +
  labs(title = "Fitted values vs Residuals")
\end{verbatim}

\begin{center}
\includegraphics[width=.9\linewidth]{fit_lmm.png}
\end{center}

That looks much better. We can now use this to predict the enrolment on a given year. For e.g.:

What is the expected fall enrolment (ROLL) given if the unemployment rate (UNEM) is 14\% and if there are 50,000 graduates (HGRAD)?

\begin{verbatim}
-8255.8 + 698.2681316 *14 + 0.9423 * 50000
\end{verbatim}

\begin{verbatim}
[1] 48634.95
\end{verbatim}

The predicted fall enrolment, given a 9\% unemployment rate and 50,000 student spring high school graduating class, is 48635.

What if you had a completely different dataset on which you'd like to apply this model for a prediction?

Well, the solution is simply to organise the data as was done in the model and use the prediction function. Here are the steps:

\begin{center}
\includegraphics[width=.9\linewidth]{flow_predict.png}
\end{center}

\begin{verbatim}
newdat <- data.frame(ROLL = rep(NA, 300), HGRAD = floor(runif(300, min=9000, max=20000)), UNEM = (runif(300, min=5, max=11)))
newdat <- rbind(newdat, c(NA, 50000, 14)) # add the values we tested in the previous step
newdat$ROLL <- predict(fit.lmm, newdat)
tail(newdat)
\end{verbatim}

\begin{verbatim}
         ROLL HGRAD      UNEM
296 14669.111 17977  8.571995
297 16915.193 19599  9.599837
298 17343.742 19347 10.553629
299  9928.925 11285 10.814015
300  7491.470 11833  6.583802
301 48633.846 50000 14.000000
\end{verbatim}

The tail command shows the last six rows of the data frame. As you can see, the \texttt{predict} function works as expected.

---

Bonus: A really neat function to plot the data and variables of a model. Copied from \url{https://stackoverflow.com/questions/4357031/qqnorm-and-qqline-in-ggplot2/}. The site Stackoverflow is a huge help.

Now use this function as below:
\begin{verbatim}
x <- rstudent(fit.lmm)
gg_qq(x)
\end{verbatim}

\begin{center}
\includegraphics[width=.9\linewidth]{Residuals.png}
\end{center}
\end{document}
